%--------------------------------------------------------------------------
%this function is to get all the parameters from parameters setting GUI
%
%Chen Zhifeng
%UFID 12181197
%2008-10-14
%zhifeng@ecel.ufl.edu
%--------------------------------------------------------------------------
function para_setting = get_para(handles)

%get the configuration setting
para_setting.conf.videos = get(handles.listbox_video,'String');

contents = get(handles.popupmenu_store,'String');
para_setting.conf.folder = contents{get(handles.popupmenu_store,'Value')};

para_setting.conf.loop_number = str2num(get(handles.edit_loop_number,'String'));

if (get(handles.checkbox_temp,'Value') == get(handles.checkbox_temp,'Max'))
    para_setting.conf.save_temp = 1; % then checkbox is checked-take approriate action
else
    para_setting.conf.save_temp = 0; % checkbox is not checked-take approriate action
end

%get the image parameters setting
para_setting.image.width = str2num(get(handles.edit_image_width,'String'));
para_setting.image.height = str2num(get(handles.edit_image_height,'String'));
para_setting.image.MB_per_slice = str2num(get(handles.edit_MB_per_slice,'String'));
para_setting.image.frame_number = str2num(get(handles.edit_frame_number,'String'));
para_setting.image.frame_offset = str2num(get(handles.edit_frame_offset,'String'));
para_setting.image.subsampling = get(handles.edit_subsampling,'String');
para_setting.image.subpel_ME = str2num(get(handles.edit_subpel_ME,'String'));
para_setting.image.FMO_type = str2num(get(handles.edit_FMO_type,'String'));

%get the channel parameters setting (Note that it is different from get the advanced setting in that 0 means no packet error, i.e. same as unchecked)
para_setting.chan.channels = get(handles.popupmenu_channel,'String');


%get the advanced setting
para_setting.advan.alg1.input = str2num(get(handles.edit_alg1,'String'));
if (get(handles.checkbox_alg1,'Value') == get(handles.checkbox_alg1,'Max'))
    para_setting.advan.alg1.flag = 1; % then checkbox is checked-take approriate action
else
    para_setting.advan.alg1.flag = 0; % checkbox is not checked-take approriate action
end

para_setting.advan.alg2.input = str2num(get(handles.edit_alg2,'String'));
if (get(handles.checkbox_alg2,'Value') == get(handles.checkbox_alg2,'Max'))
    para_setting.advan.alg2.flag = 1; % then checkbox is checked-take approriate action
else
    para_setting.advan.alg2.flag = 0; % checkbox is not checked-take approriate action
end

para_setting.advan.alg3.input = str2num(get(handles.edit_alg3,'String'));
if (get(handles.checkbox_alg3,'Value') == get(handles.checkbox_alg3,'Max'))
    para_setting.advan.alg3.flag = 1; % then checkbox is checked-take approriate action
else
    para_setting.advan.alg3.flag = 0; % checkbox is not checked-take approriate action
end

para_setting.advan.alg4.input = str2num(get(handles.edit_alg4,'String'));
if (get(handles.checkbox_alg4,'Value') == get(handles.checkbox_alg4,'Max'))
    para_setting.advan.alg4.flag = 1; % then checkbox is checked-take approriate action
else
    para_setting.advan.alg4.flag = 0; % checkbox is not checked-take approriate action
end

para_setting.advan.alg5.input = str2num(get(handles.edit_alg5,'String'));
if (get(handles.checkbox_alg5,'Value') == get(handles.checkbox_alg5,'Max'))
    para_setting.advan.alg5.flag = 1; % then checkbox is checked-take approriate action
else
    para_setting.advan.alg5.flag = 0; % checkbox is not checked-take approriate action
end

para_setting.advan.alg6.input = str2num(get(handles.edit_alg6,'String'));
if (get(handles.checkbox_alg6,'Value') == get(handles.checkbox_alg6,'Max'))
    para_setting.advan.alg6.flag = 1; % then checkbox is checked-take approriate action
else
    para_setting.advan.alg6.flag = 0; % checkbox is not checked-take approriate action
end

if (get(handles.checkbox_BS,'Value') == get(handles.checkbox_BS,'Max'))
    para_setting.advan.disp_BS = 1; % then checkbox is checked-take approriate action
else
    para_setting.advan.disp_BS = 0; % checkbox is not checked-take approriate action
end
if (get(handles.checkbox_BS_per_frame,'Value') == get(handles.checkbox_BS_per_frame,'Max'))
    para_setting.advan.disp_BS_for_each_frame = 1; % then checkbox is checked-take approriate action
else
    para_setting.advan.disp_BS_for_each_frame = 0; % then checkbox is checked-take approriate action
end

if (get(handles.checkbox_CC,'Value') == get(handles.checkbox_CC,'Max'))
    para_setting.advan.disp_CC = 1; % then checkbox is checked-take approriate action
else
    para_setting.advan.disp_CC = 0; % checkbox is not checked-take approriate action
end
if (get(handles.checkbox_CC_per_frame,'Value') == get(handles.checkbox_CC_per_frame,'Max'))
    para_setting.advan.disp_CC_for_each_frame = 1; % then checkbox is checked-take approriate action
else
    para_setting.advan.disp_CC_for_each_frame = 0; % then checkbox is checked-take approriate action
end

if (get(handles.checkbox_JP,'Value') == get(handles.checkbox_JP,'Max'))
    para_setting.advan.disp_JP = 1; % then checkbox is checked-take approriate action
else
    para_setting.advan.disp_JP = 0; % checkbox is not checked-take approriate action
end
if (get(handles.checkbox_JP_per_frame,'Value') == get(handles.checkbox_JP_per_frame,'Max'))
    para_setting.advan.disp_JP_for_each_frame = 1; % then checkbox is checked-take approriate action
else
    para_setting.advan.disp_JP_for_each_frame = 0; % then checkbox is checked-take approriate action
end

if (get(handles.checkbox_CP,'Value') == get(handles.checkbox_CP,'Max'))
    para_setting.advan.disp_CP = 1; % then checkbox is checked-take approriate action
else
    para_setting.advan.disp_CP = 0; % checkbox is not checked-take approriate action
end
if (get(handles.checkbox_CP_per_frame,'Value') == get(handles.checkbox_CP_per_frame,'Max'))
    para_setting.advan.disp_CP_for_each_frame = 1; % then checkbox is checked-take approriate action
else
    para_setting.advan.disp_CP_for_each_frame = 0; % then checkbox is checked-take approriate action
end


%get the handle for display message 
para_setting.output.handle_display_message = handles.listbox_display;



