%--------------------------------------------------------------------------
%this function is to initialize the variables
%
%Chen Zhifeng
%UFID 12181197
%2008-07-17
%zhifeng@ecel.ufl.edu
%--------------------------------------------------------------------------
function statistic = statistic_IDR(para_image)
%initial the variables which introduce distortion by propagation

global block_size; %the minimum block for one motion vector

image_width = para_image.width;
image_height = para_image.height;

statistic.MV.whole_frame.x = zeros(image_width / block_size * image_height / block_size, 1);
statistic.MV.whole_frame.x_mean = 0;
statistic.MV.whole_frame.x_var = 0;
statistic.MV.whole_frame.y = zeros(image_width / block_size * image_height / block_size, 1);
statistic.MV.whole_frame.y_mean = 0;
statistic.MV.whole_frame.y_var = 0;

statistic.MV.whole_frame.length = zeros(image_width / block_size * image_height / block_size, 1);
statistic.MV.whole_frame.rho_x_y  = 0;

statistic.Y.whole_frame.residue = zeros(image_width * image_height, 1);
statistic.Y.whole_frame.residue_mean = 0;
statistic.Y.whole_frame.residue_MSE = 0;
statistic.Y.whole_frame.rho_MV_resi = 0;
statistic.Y.whole_frame.residue_clip = zeros(image_width * image_height, 1);
statistic.Y.whole_frame.residue_clip_mean = 0;
statistic.Y.whole_frame.residue_clip_MSE = 0;

statistic.Y.whole_frame.concealment_error = zeros(image_width * image_height, 1);
statistic.Y.whole_frame.concealment_error_mean = 0;
statistic.Y.whole_frame.concealment_error_MSE = 0;
statistic.Y.whole_frame.rho_MV_conc = 0;
statistic.Y.whole_frame.concealment_error_clip = zeros(image_width * image_height, 1);
statistic.Y.whole_frame.concealment_error_clip_mean = 0;
statistic.Y.whole_frame.concealment_error_clip_MSE = 0;

statistic.Y.whole_frame.predicted = zeros(image_width * image_height, 1)+128;
statistic.Y.whole_frame.predicted_mean = 128;
statistic.Y.whole_frame.predicted_var = 0;

statistic.Y.whole_frame.reconstructed = zeros(image_width * image_height, 1)+128;
statistic.Y.whole_frame.reconstructed_mean = 128;
statistic.Y.whole_frame.reconstructed_var = 0;

statistic.Y.whole_frame.both_error = zeros(image_width * image_height, 1);
statistic.Y.whole_frame.both_error_mean = 0;
statistic.Y.whole_frame.both_error_MSE = 0;

statistic.Y.whole_frame.prop_clip_resi = zeros(image_width * image_height, 1);
statistic.Y.whole_frame.prop_clip_resi_mean = 0;
statistic.Y.whole_frame.prop_clip_resi_MSE = 0;
statistic.Y.whole_frame.prop_clip_resi_factor = 0;

statistic.Y.whole_frame.prop_clip_conc = zeros(image_width * image_height, 1);
statistic.Y.whole_frame.prop_clip_conc_mean = 0;
statistic.Y.whole_frame.prop_clip_conc_MSE = 0;
statistic.Y.whole_frame.prop_clip_conc_factor = 0;

statistic.Y.whole_frame.prop_clip_both = zeros(image_width * image_height, 1);
statistic.Y.whole_frame.prop_clip_both_mean = 0;
statistic.Y.whole_frame.prop_clip_both_MSE = 0;
statistic.Y.whole_frame.prop_clip_both_factor = 0;

% statistic.Y.whole_frame.delta_Nr_Nm_Nq = zeros(image_width * image_height, 1);
% statistic.Y.whole_frame.delta_Nr_m_Nq = zeros(image_width * image_height, 1);
% statistic.Y.whole_frame.delta_Nr_Nm_qResi = zeros(image_width * image_height, 1);
% statistic.Y.whole_frame.delta_Nr_m_qResi = zeros(image_width * image_height, 1);
% statistic.Y.whole_frame.delta_Nr_Nm_qConc = zeros(image_width * image_height, 1);
% statistic.Y.whole_frame.delta_Nr_m_qConc = zeros(image_width * image_height, 1);
% statistic.Y.whole_frame.delta_Nr_Nm_pBoth = zeros(image_width * image_height, 1);
% statistic.Y.whole_frame.delta_Nr_m_pBoth = zeros(image_width * image_height, 1);

statistic.Y.whole_frame.rho_resi_pred = 0;
statistic.Y.whole_frame.rho_resi_recon = 0;
statistic.Y.whole_frame.rho_curr_conc_pred = 0;
statistic.Y.whole_frame.rho_curr_conc_last_recon = 0;

statistic.Y.whole_frame.rho_curr_resi_curr_conc = 0;
statistic.Y.whole_frame.rho_curr_resi_last_resi = 0;
statistic.Y.whole_frame.rho_curr_resi_last_conc = 0;
statistic.Y.whole_frame.rho_curr_conc_last_resi = 0;
statistic.Y.whole_frame.rho_curr_conc_last_conc = 0;

statistic.Y.whole_frame.rho_crlr_align = 0;
statistic.Y.whole_frame.rho_crlc_align = 0;
statistic.Y.whole_frame.rho_cclr_align = 0;
statistic.Y.whole_frame.rho_cclc_align = 0;
